/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 * Apache Antタスク [BlancoNLpackGeneratorTranslationFragmentToPleiades]のクラス
 */
package blanco.nlpack.generator.task;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import blanco.nlpack.generator.task.valueobject.BlancoNLpackGeneratorTranslationFragmentToPleiadesProcessInput;

/**
 * Apache Antタスク [BlancoNLpackGeneratorTranslationFragmentToPleiades]のクラス。
 *
 * 指定されたフラグメントファイルを Pleiades形式のプロパティファイルに変換します。<br>
 * このクラスでは、Apache Antタスクで一般的に必要なチェックなどのコーディングを肩代わりします。
 * 実際の処理は パッケージ[blanco.nlpack.generator.task]にBlancoNLpackGeneratorTranslationFragmentToPleiadesBatchProcessクラスを作成して記述してください。<br>
 * <br>
 * Antタスクへの組み込み例<br>
 * <pre>
 * &lt;taskdef name=&quot;blanconlpackgeneratortranslationfragmenttopleiades&quot; classname=&quot;blanco.nlpack.generator.task.BlancoNLpackGeneratorTranslationFragmentToPleiadesTask">
 *     &lt;classpath&gt;
 *         &lt;fileset dir=&quot;lib&quot; includes=&quot;*.jar&quot; /&gt;
 *         &lt;fileset dir=&quot;lib.ant&quot; includes=&quot;*.jar&quot; /&gt;
 *     &lt;/classpath&gt;
 * &lt;/taskdef&gt;
 * </pre>
 */
public class BlancoNLpackGeneratorTranslationFragmentToPleiadesTask extends Task {
    /**
     * 指定されたフラグメントファイルを Pleiades形式のプロパティファイルに変換します。
     */
    protected BlancoNLpackGeneratorTranslationFragmentToPleiadesProcessInput fInput = new BlancoNLpackGeneratorTranslationFragmentToPleiadesProcessInput();

    /**
     * 指定されたフラグメントファイルを Pleiades形式のプロパティファイルに変換します。
     */
    protected boolean fIsFieldSourcefileProcessed = false;

    /**
     * 指定されたフラグメントファイルを Pleiades形式のプロパティファイルに変換します。
     */
    protected boolean fIsFieldTargetfileProcessed = false;

    /**
     * 指定されたフラグメントファイルを Pleiades形式のプロパティファイルに変換します。
     */
    protected boolean fIsFieldSourcedirProcessed = false;

    /**
     * 指定されたフラグメントファイルを Pleiades形式のプロパティファイルに変換します。
     */
    protected boolean fIsFieldTargetdirProcessed = false;

    /**
     * 指定されたフラグメントファイルを Pleiades形式のプロパティファイルに変換します。
     */
    protected boolean fIsFieldContributorProcessed = false;

    /**
     * 指定されたフラグメントファイルを Pleiades形式のプロパティファイルに変換します。
     */
    protected boolean fIsFieldIsoutputdateProcessed = false;

    /**
     * 指定されたフラグメントファイルを Pleiades形式のプロパティファイルに変換します。
     */
    protected boolean fIsFieldIscheckbundleuriasbabelProcessed = false;

    /**
     * verboseモードで動作させるかどうか。
     *
     * @param arg verboseモードで動作させるかどうか。
     */
    public void setVerbose(final boolean arg) {
        fInput.setVerbose(arg);
    }

    /**
     * verboseモードで動作させるかどうか。
     *
     * @return verboseモードで動作させるかどうか。
     */
    public boolean getVerbose() {
        return fInput.getVerbose();
    }

    /**
     * Antタスクの[sourcefile]アトリビュートのセッターメソッド。
     *
     * 項目番号: 1<br>
     * 入力ファイル。<br>
     *
     * @param arg セットしたい値
     */
    public void setSourcefile(final String arg) {
        fInput.setSourcefile(arg);
        fIsFieldSourcefileProcessed = true;
    }

    /**
     * Antタスクの[sourcefile]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 1<br>
     * 入力ファイル。<br>
     * デフォルト値[conf/BlancoNLpackGeneratorTranslationFragment.csv]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getSourcefile() {
        return fInput.getSourcefile();
    }

    /**
     * Antタスクの[targetfile]アトリビュートのセッターメソッド。
     *
     * 項目番号: 2<br>
     * 出力ファイル。<br>
     *
     * @param arg セットしたい値
     */
    public void setTargetfile(final String arg) {
        fInput.setTargetfile(arg);
        fIsFieldTargetfileProcessed = true;
    }

    /**
     * Antタスクの[targetfile]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 2<br>
     * 出力ファイル。<br>
     * デフォルト値[tmp/BlancoNLpackGeneratorTranslationFragment.properties]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getTargetfile() {
        return fInput.getTargetfile();
    }

    /**
     * Antタスクの[sourcedir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 3<br>
     * 入力ファイルが格納されたディレクトリ。sourcefileかいずれかを指定。<br>
     *
     * @param arg セットしたい値
     */
    public void setSourcedir(final String arg) {
        fInput.setSourcedir(arg);
        fIsFieldSourcedirProcessed = true;
    }

    /**
     * Antタスクの[sourcedir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 3<br>
     * 入力ファイルが格納されたディレクトリ。sourcefileかいずれかを指定。<br>
     *
     * @return このフィールドの値
     */
    public String getSourcedir() {
        return fInput.getSourcedir();
    }

    /**
     * Antタスクの[targetdir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 4<br>
     * 出力ファイルが格納されたディレクトリ。targetfileかいずれかを指定。<br>
     *
     * @param arg セットしたい値
     */
    public void setTargetdir(final String arg) {
        fInput.setTargetdir(arg);
        fIsFieldTargetdirProcessed = true;
    }

    /**
     * Antタスクの[targetdir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 4<br>
     * 出力ファイルが格納されたディレクトリ。targetfileかいずれかを指定。<br>
     *
     * @return このフィールドの値
     */
    public String getTargetdir() {
        return fInput.getTargetdir();
    }

    /**
     * Antタスクの[contributor]アトリビュートのセッターメソッド。
     *
     * 項目番号: 5<br>
     * 貢献者の名前。<br>
     *
     * @param arg セットしたい値
     */
    public void setContributor(final String arg) {
        fInput.setContributor(arg);
        fIsFieldContributorProcessed = true;
    }

    /**
     * Antタスクの[contributor]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 5<br>
     * 貢献者の名前。<br>
     * デフォルト値[&lt;contributor&gt;]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getContributor() {
        return fInput.getContributor();
    }

    /**
     * Antタスクの[isoutputdate]アトリビュートのセッターメソッド。
     *
     * 項目番号: 6<br>
     * 日付を出力するかどうか。<br>
     *
     * @param arg セットしたい値
     */
    public void setIsoutputdate(final boolean arg) {
        fInput.setIsoutputdate(arg);
        fIsFieldIsoutputdateProcessed = true;
    }

    /**
     * Antタスクの[isoutputdate]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 6<br>
     * 日付を出力するかどうか。<br>
     * デフォルト値[true]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public boolean getIsoutputdate() {
        return fInput.getIsoutputdate();
    }

    /**
     * Antタスクの[ischeckbundleuriasbabel]アトリビュートのセッターメソッド。
     *
     * 項目番号: 7<br>
     * BundleURI列が babel: から始まっていることを確認するかどうか。<br>
     *
     * @param arg セットしたい値
     */
    public void setIscheckbundleuriasbabel(final boolean arg) {
        fInput.setIscheckbundleuriasbabel(arg);
        fIsFieldIscheckbundleuriasbabelProcessed = true;
    }

    /**
     * Antタスクの[ischeckbundleuriasbabel]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 7<br>
     * BundleURI列が babel: から始まっていることを確認するかどうか。<br>
     * デフォルト値[true]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public boolean getIscheckbundleuriasbabel() {
        return fInput.getIscheckbundleuriasbabel();
    }

    /**
     * Antタスクのメイン処理。Apache Antから このメソッドが呼び出されます。
     *
     * @throws BuildException タスクとしての例外が発生した場合。
     */
    public final void execute() throws BuildException {
        System.out.println("BlancoNLpackGeneratorTranslationFragmentToPleiadesTask begin.");

        if (getVerbose()) {
            System.out.println("- verbose:[true]");
            System.out.println("- sourcefile:[" + getSourcefile() + "]");
            System.out.println("- targetfile:[" + getTargetfile() + "]");
            System.out.println("- sourcedir:[" + getSourcedir() + "]");
            System.out.println("- targetdir:[" + getTargetdir() + "]");
            System.out.println("- contributor:[" + getContributor() + "]");
            System.out.println("- isoutputdate:[" + getIsoutputdate() + "]");
            System.out.println("- ischeckbundleuriasbabel:[" + getIscheckbundleuriasbabel() + "]");
        }

        try {
            // 実際のAntタスクの主処理を実行します。
            // この箇所でコンパイルエラーが発生する場合、BlancoNLpackGeneratorTranslationFragmentToPleiadesProcessインタフェースを実装して blanco.nlpack.generator.taskパッケージに BlancoNLpackGeneratorTranslationFragmentToPleiadesProcessImplクラスを作成することにより解決できる場合があります。
            final BlancoNLpackGeneratorTranslationFragmentToPleiadesProcess proc = new BlancoNLpackGeneratorTranslationFragmentToPleiadesProcessImpl();
            if (proc.execute(fInput) != BlancoNLpackGeneratorTranslationFragmentToPleiadesBatchProcess.END_SUCCESS) {
                throw new BuildException("タスクは異常終了しました。");
            }
        } catch (IllegalArgumentException e) {
            if (getVerbose()) {
                e.printStackTrace();
            }
            throw new BuildException(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中に例外が発生しました。処理を中断します。" + e.toString());
        } catch (Error e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中にエラーが発生しました。処理を中断します。" + e.toString());
        }
    }
}
